Gentoo Forums
Gentoo Forums
Gentoo Forums
Quick Search: in
[overlay inside] icc-11.1.069 (both IA-32 and INTEL 64)
View unanswered posts
View posts from last 24 hours

 
Reply to topic    Gentoo Forums Forum Index Unsupported Software
View previous topic :: View next topic  
Author Message
darkbasic
Tux's lil' helper
Tux's lil' helper


Joined: 06 Sep 2006
Posts: 133

PostPosted: Sun Mar 14, 2010 3:21 pm    Post subject: [overlay inside] icc-11.1.069 (both IA-32 and INTEL 64) Reply with quote

It's the latest version of the icc compiler and contains compilers for both ia32 and intel64, which are needed to compile the kernel patched with linuxdna (unlike gentoo's ebuild which contains only intel64).

(echo "source /usr/portage/local/layman/make.conf" >> /etc/make.conf)
layman -f -o http://darkbasic.homelinux.com/linuxdna.xml -a linuxdna

Try it and let me know if it works for you.

Cheers,
Darkbasic
_________________
Computers are like air conditioners:
they stop working properly when you open Windows...

Coltiva Linux, Windows si pianta da solo.


http://www.linuxsystems.it/
Back to top
View user's profile Send private message
paluszak
Apprentice
Apprentice


Joined: 28 Jun 2004
Posts: 228
Location: Warsaw, Poland

PostPosted: Fri Apr 23, 2010 12:48 pm    Post subject: Reply with quote

It works fine, thanks!

I decided to gove ICC a try and custom compiled some multimedia libs, like lame. To my surprise, the resulting code is much slower than the one from ICC 10 and slower than GCC. I'm baffled. Maybe I'm mixing something up with optimization options, but "-xN -O3 -fomit-frame-pointer -no-prec-div -ipo -gcc" seems ok...

J.
Back to top
View user's profile Send private message
mothersh1p
n00b
n00b


Joined: 21 Apr 2010
Posts: 15

PostPosted: Fri Apr 23, 2010 4:04 pm    Post subject: Reply with quote

Please try this flags:

Code:

-O3 -no-prec-div -static -unroll-aggressive -vec-guard-write -fp-math fast=2 -ip -fno-builtin -fomit-frame-pointer -w


or

Code:

-O2 -no-prec-div -static -unroll-aggressive -vec-guard-write -fp-math fast=2 -ip -fno-builtin -fomit-frame-pointer -w


-O3 is not necessary faster, but produces always bigger binaries!
Back to top
View user's profile Send private message
paluszak
Apprentice
Apprentice


Joined: 28 Jun 2004
Posts: 228
Location: Warsaw, Poland

PostPosted: Fri Apr 23, 2010 9:14 pm    Post subject: Reply with quote

mothersh1p wrote:
Please try this flags:

Code:

-O3 -no-prec-div -static -unroll-aggressive -vec-guard-write -fp-math fast=2 -ip -fno-builtin -fomit-frame-pointer -w


(...)


Why do you use -ip instead of -ipo? I thought -ipo produces more oprimized code.

I compiled ffmpeg and it's a whooping 40% faster, though the fact of getting the latest svn instead of the versions in portage might have played its role. No practical difference for flac and lrzip, though.

J.
Back to top
View user's profile Send private message
Shining Arcanine
Veteran
Veteran


Joined: 24 Sep 2009
Posts: 1110

PostPosted: Fri Apr 23, 2010 10:05 pm    Post subject: Reply with quote

There is a bump request in Gentoo's bugzilla regarding this:

https://bugs.gentoo.org/show_bug.cgi?id=316663

Perhaps you could post your ebuild there for possible inclusion into portage.
Back to top
View user's profile Send private message
mothersh1p
n00b
n00b


Joined: 21 Apr 2010
Posts: 15

PostPosted: Fri Apr 23, 2010 10:51 pm    Post subject: Reply with quote

paluszak wrote:
mothersh1p wrote:
Please try this flags:

Code:

-O3 -no-prec-div -static -unroll-aggressive -vec-guard-write -fp-math fast=2 -ip -fno-builtin -fomit-frame-pointer -w


(...)


Why do you use -ip instead of -ipo? I thought -ipo produces more oprimized code.

I compiled ffmpeg and it's a whooping 40% faster, though the fact of getting the latest svn instead of the versions in portage might have played its role. No practical difference for flac and lrzip, though.

J.


I'm sorry! I thought you were talking about the kernel. -ipo is of course faster than -ip. I don't know much about C-programming either.
Back to top
View user's profile Send private message
hadogenes
Tux's lil' helper
Tux's lil' helper


Joined: 05 Jan 2005
Posts: 107
Location: Poland, Poznan

PostPosted: Sat Apr 24, 2010 11:01 pm    Post subject: Reply with quote

could you add LDPATH and LIBRARY_PATH for idb (/opt/intel/Compiler/11.1/069/idb/lib/intel64)?

I added function in my local ebuild:
Code:
make_env_file() {
   local envf="05icfc"

   local ICC_PATH="${EROOT}${DESTINATION}/bin/${IARCH}"
   local ICC_ROOTPATH="${EROOT}${DESTINATION}/bin/${IARCH}"
   local ICC_LDPATH="${EROOT}${DESTINATION}/lib/${IARCH}"
   local ICC_LIBRARY_PATH="${EROOT}${DESTINATION}/lib/${IARCH}"
   local ICC_NLSPATH="${EROOT}${DESTINATION}/lib/locale/en_US/%N"
   local ICC_MANPATH="${EROOT}${DESTINATION}/man/en_US"


   if use idb; then
      if ! has_version "~dev-lang/ifc-${PV}" || ! built_with_use dev-lang/ifc idb; then
         ICC_LDPATH="${ICC_LDPATH}:${EROOT}${DESTINATION}/idb/lib/${IARCH}"
         ICC_LIBRARY_PATH="${ICC_LIBRARY_PATH}:${EROOT}${DESTINATION}/idb/lib/${IARCH}"
      fi
   fi

   cat > ${envf} <<-EOF
      PATH="${ICC_PATH}"
      ROOTPATH="${ICC_ROOTPATH}"
      LDPATH="${ICC_LDPATH}"
      LIBRARY_PATH="${ICC_LIBRARY_PATH}"
      NLSPATH="${ICC_NLSPATH}"
      MANPATH="${ICC_MANPATH}"
   EOF

   if [[ ! -e "${EROOT}"etc/env.d/${envf} ]] ||
      [[ -n $(diff "${EROOT}"etc/env.d/${envf} ./${envf}) ]]; then
      doenvd ${envf} || die "doenvd ${envf} failed"
   fi
}


what do you think?
Back to top
View user's profile Send private message
costel78
Guru
Guru


Joined: 20 Apr 2007
Posts: 321

PostPosted: Mon May 03, 2010 5:47 am    Post subject: Reply with quote

I observed that icc-11.1.072 are available for download. The new PID is 1768.
I changed the pid in ebuild, digest it and it seems it working.
Anyway, the latest icc version seems to be 11.1.080.
Is Intel politic that latest version not to be freely available for non-commercial use ?
_________________
Sorry for my English. I'm still learning this language.
Back to top
View user's profile Send private message
mothersh1p
n00b
n00b


Joined: 21 Apr 2010
Posts: 15

PostPosted: Mon May 03, 2010 12:44 pm    Post subject: Reply with quote

costel78 wrote:
I observed that icc-11.1.072 are available for download. The new PID is 1768.
I changed the pid in ebuild, digest it and it seems it working.
Anyway, the latest icc version seems to be 11.1.080.
Is Intel politic that latest version not to be freely available for non-commercial use ?


Here is a new 32-Bit patch:

> http://www.chihoang.de/uploads/media/dna-2.6.34-rc5-intel32-4.patch


Enjoy!
Back to top
View user's profile Send private message
costel78
Guru
Guru


Joined: 20 Apr 2007
Posts: 321

PostPosted: Mon May 03, 2010 7:56 pm    Post subject: Reply with quote

That's great news mothersh1p!

Regarding overlay:
Does anybody know why icc 11.1.080 is not available for download ? It's that Intel politics ?
Or did anyone tested 11.1.072 version ?
_________________
Sorry for my English. I'm still learning this language.
Back to top
View user's profile Send private message
mothersh1p
n00b
n00b


Joined: 21 Apr 2010
Posts: 15

PostPosted: Mon May 03, 2010 9:14 pm    Post subject: Reply with quote

costel78 wrote:

Does anybody know why icc 11.1.080 is not available for download ? It's that Intel politics ?
Or did anyone tested 11.1.072 version ?


Where can I download 11.1.080? Is this an official release?
Back to top
View user's profile Send private message
costel78
Guru
Guru


Joined: 20 Apr 2007
Posts: 321

PostPosted: Tue May 04, 2010 5:40 am    Post subject: Reply with quote

mothersh1p wrote:
Where can I download 11.1.080? Is this an official release?


That was exactly my questions. On Intel forum I found references to 11.1.080 version.
I presumed that Intel does not always give to free download the latest version.
_________________
Sorry for my English. I'm still learning this language.
Back to top
View user's profile Send private message
darkbasic
Tux's lil' helper
Tux's lil' helper


Joined: 06 Sep 2006
Posts: 133

PostPosted: Tue May 04, 2010 11:51 am    Post subject: Reply with quote

hadogenes wrote:
could you add LDPATH and LIBRARY_PATH for idb (/opt/intel/Compiler/11.1/069/idb/lib/intel64)?

I will add it in the next version. Should I wait for 11.1.080? Do someone know when will it be availale for download?
_________________
Computers are like air conditioners:
they stop working properly when you open Windows...

Coltiva Linux, Windows si pianta da solo.


http://www.linuxsystems.it/
Back to top
View user's profile Send private message
costel78
Guru
Guru


Joined: 20 Apr 2007
Posts: 321

PostPosted: Tue May 04, 2010 10:02 pm    Post subject: Reply with quote

11.1.080 version is available only for Mac OS.
I presume that there are separate benches for Windows, Linux And MacOS.
Anyway, it's only a presumption.
_________________
Sorry for my English. I'm still learning this language.
Back to top
View user's profile Send private message
Shining Arcanine
Veteran
Veteran


Joined: 24 Sep 2009
Posts: 1110

PostPosted: Mon May 10, 2010 2:21 am    Post subject: Reply with quote

Does anyone have an ebuild for 11.1.072?
Back to top
View user's profile Send private message
costel78
Guru
Guru


Joined: 20 Apr 2007
Posts: 321

PostPosted: Mon May 10, 2010 5:17 am    Post subject: Reply with quote

It's based on 11.1.069. The only change is: PID=1768

Code:
# Copyright 1999-2009 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: /var/cvsroot/gentoo-x86/dev-lang/icc/icc-11.1.069.ebuild,v 1.6 2010/02/25 03:48:20 bicatali Exp $

EAPI=2

inherit rpm versionator check-reqs

PB=cproc
PACKAGEID="l_${PB}_p_${PV}"
RELEASE="$(get_version_component_range 1-2)"
BUILD="$(get_version_component_range 3)"
PID=1768

DESCRIPTION="Intel compiler suite for Linux"
HOMEPAGE="http://www.intel.com/software/products/compilers/clin/"
SRC_COM="http://registrationcenter-download.intel.com/irc_nas/${PID}/${PACKAGEID}"
SRC_URI="amd64? ( ${SRC_COM}.tgz )"
#   ia64? ( ${SRC_COM}_ia64.tgz )
#   x86?  ( ${SRC_COM}_ia32.tgz )"

LICENSE="Intel-SDP"
SLOT="0"
IUSE="eclipse +idb ipp mkl"
KEYWORDS="~amd64 ~x86"

RESTRICT="strip binchecks"

DEPEND=""
RDEPEND="~virtual/libstdc++-3.3
   amd64? ( app-emulation/emul-linux-x86-compat )
   eclipse? ( >=dev-util/eclipse-sdk-3.4 )"

DESTINATION="opt/intel/Compiler/${RELEASE}/${BUILD}"

pkg_setup() {
   CHECKREQS_MEMORY=1024
   CHECKREQS_DISK_BUILD=2048
   use idb && use ipp && use mkl && CHECKREQS_DISK_BUILD=3072
   check_reqs
   IARCH=ia32
   use amd64 && IARCH=intel64
   use ia64 && IARCH=ia64
}

src_unpack() {
   unpack ${A}
   mv "${WORKDIR}"/l_* "${S}"
   cd "${S}"
   # tbb is open source, thus built from sources in dev-cpp/tbb
   rm -f rpm/*tbb*.rpm
   use idb || rm -f rpm/*idb*.rpm
   use ipp || rm -f rpm/*ipp*.rpm
   use mkl || rm -f rpm/*mkl*.rpm
   use eclipse || rm -f rpm/*cdt*.rpm
   if has_version "~dev-lang/ifc-${PV}"; then
      rm -f rpm/*cprolib*.rpm
      use idb && built_with_use dev-lang/ifc idb && rm -f rpm/*idb*.rpm
      use mkl && built_with_use dev-lang/ifc mkl && rm -f rpm/*mkl*.rpm
   fi
   for x in rpm/intel*.rpm; do
      einfo "Extracting $(basename ${x})..."
      rpm_unpack ./${x} || die "rpm_unpack ${x} failed"
   done
}

link_eclipse_plugins() {
   ECLIPSE_V="$1"
   CDT_V="$2"
   einfo "Linking eclipse (v${ECLIPSE_V}) plugin cdt (v${CDT_V})"
   dodir /usr/$(get_libdir)/eclipse-${ECLIPSE_V}/plugins
   dodir /usr/$(get_libdir)/eclipse-${ECLIPSE_V}/features

   for f in "${DESTINATION}/eclipse_support/cdt${CDT_V}/eclipse/plugins"/*; do
      dosym "${ROOT}${f}" /usr/$(get_libdir)/eclipse-${ECLIPSE_V}/plugins
   done

   for f in "${DESTINATION}/eclipse_support/cdt${CDT_V}/eclipse/features"/*; do
      dosym "${ROOT}${f}" /usr/$(get_libdir)/eclipse-${ECLIPSE_V}/features
   done
   eend $?
}

src_prepare() {
   # from the PURGE_UB804_FNP in pset/install_cc.sh
   # rm -f "${DESTINATION}"/lib/*/*libFNP.so || die

   # extract the tag function from the original install
   sed -n \
      -e "s|find \$DESTINATION|find ${DESTINATION}|g" \
      -e "s|@\$DESTINATION|@${ROOT}${DESTINATION}|g" \
      -e '/^UNTAG_CFG_FILES[[:space:]]*(/,/^}/p' \
      pset/install_cc.sh > tag.sh || die
   # fix world writeable files
   [[ -d ${DESTINATION}/mkl ]] && chmod 644 \
      ${DESTINATION}/mkl/tools/{environment,builder}/* \
      ${DESTINATION}/mkl/tools/plugins/*/*
   # remove for collision (bug #288038)
   has_version "~dev-lang/ifc-${PV}" && \
      rm -f ${DESTINATION}/lib/*/locale/*/flexnet.cat
}

src_install() {
   einfo "Tagging"
   . ./tag.sh
   UNTAG_CFG_FILES

   keepdir /opt/intel/licenses
   einfo "Copying files"
   dodir "${DESTINATION}"
   cp -pPR \
      ${DESTINATION}/* \
      "${D}"/${DESTINATION}/ \
      || die "Copying ${PN} failed"

   local envf=05icfc
if use amd64 ; then
echo "Found AMD64"
cat > ${envf} <<-EOF
PATH="${ROOT}${DESTINATION}/bin/${IARCH}:${ROOT}${DESTINATION}/bin/ia32"
ROOTPATH="${ROOT}${DESTINATION}/bin/${IARCH}:${ROOT}${DESTINATION}/bin/ia32"
LDPATH="${ROOT}${DESTINATION}/lib/${IARCH}:${ROOT}${DESTINATION}/lib/ia32"
LIBRARY_PATH="${ROOT}${DESTINATION}/lib/${IARCH}:${ROOT}${DESTINATION}/lib/ia32"
NLSPATH="${ROOT}${DESTINATION}/lib/locale/${IARCH}/en_US/%N"
MANPATH="${ROOT}${DESTINATION}/man/en_US"
EOF
else
echo "Found ${IARCH}"
cat > ${envf} <<-EOF
PATH="${ROOT}${DESTINATION}/bin/${IARCH}"
ROOTPATH="${ROOT}${DESTINATION}/bin/${IARCH}"
LDPATH="${ROOT}${DESTINATION}/lib/${IARCH}"
LIBRARY_PATH="${ROOT}${DESTINATION}/lib/${IARCH}"
NLSPATH="${ROOT}${DESTINATION}/lib/locale/en_US/%N"
MANPATH="${ROOT}${DESTINATION}/man/en_US"
EOF
fi
   if [[ ! -e "${ROOT}"etc/env.d/${envf} ]] ||
      [[ -n $(diff "${ROOT}"etc/env.d/${envf} ./${envf}) ]]; then
      doenvd ${envf} || die "doenvd ${envf} failed"
   fi
   [[ -d ${DESTINATION}/idb ]] && \
      dosym ../../common/com.intel.debugger.help_1.0.0 \
      ${DESTINATION}/idb/gui/${IARCH}/plugins

   if use eclipse; then
      if has_version 'dev-util/eclipse-sdk:3.4'; then
         link_eclipse_plugins "3.4" "5.0" || die
      fi
      if has_version 'dev-util/eclipse-sdk:3.5'; then
         link_eclipse_plugins "3.5" "6.0" || die
      fi
   fi
}

pkg_postinst() {
   elog "Make sure you have recieved the an Intel license."
   elog "To receive a non-commercial license, you need to register at:"
   elog "http://software.intel.com/en-us/articles/non-commercial-software-development/"
   elog "Install the license file into ${ROOT}opt/intel/licenses."
}

_________________
Sorry for my English. I'm still learning this language.
Back to top
View user's profile Send private message
Shining Arcanine
Veteran
Veteran


Joined: 24 Sep 2009
Posts: 1110

PostPosted: Sat May 15, 2010 12:52 am    Post subject: Reply with quote

revdep-rebuild was complaining about the ebuild from the linux-dna overlay. This is a bug that was fixed in portage in dev-lang/icc-11.1.056-r1, so I modified the PID in dev-lang/icc-11.1.056-r1 to produce dev-lang/icc-11.1.069 and dev-lang/icc-11.1.072 ebuilds, which do not suffer from the bug, and posted them in the ICC bump request in Gentoo's Bugzilla.
Back to top
View user's profile Send private message
costel78
Guru
Guru


Joined: 20 Apr 2007
Posts: 321

PostPosted: Thu Nov 25, 2010 10:50 pm    Post subject: Reply with quote

Can someone make an ebuild for 12.0.84 version, please ?

Thank you!
_________________
Sorry for my English. I'm still learning this language.
Back to top
View user's profile Send private message
n3rd
Guru
Guru


Joined: 30 Apr 2005
Posts: 328

PostPosted: Fri Nov 26, 2010 7:51 pm    Post subject: Reply with quote

costel78 wrote:
Can someone make an ebuild for 12.0.84 version, please ?


You need to change:

DESTINATION="/opt/intel/composerxe-2011.0.84"

for rpm's dir from "rpm" to "rpms"

and 05icfc file need some modification.

regards,
daniel
_________________
"Jeśli coś jest niemożliwe do zrobienia, przychodzi ktoś kto o tym nie wie i robi to."
-- Albert Einstein

Zanim zadasz pytanie na forum, wykonaj: /etc/init.d/brain.
Back to top
View user's profile Send private message
n3rd
Guru
Guru


Joined: 30 Apr 2005
Posts: 328

PostPosted: Fri Nov 26, 2010 8:56 pm    Post subject: Reply with quote

btw. There is small problem with ICC headers files during glibc compilation (libio.h). I solve this problem by adding in to glibc ebuild one line at the beginning of ebuild code:

unset LIBRARY_PATH

by default, gcc searches the following directories for header files:

/usr/local/include/
/usr/include/

and for libraries:

/usr/local/lib/
/usr/lib/

so we could unset this.

regards,
daniel
_________________
"Jeśli coś jest niemożliwe do zrobienia, przychodzi ktoś kto o tym nie wie i robi to."
-- Albert Einstein

Zanim zadasz pytanie na forum, wykonaj: /etc/init.d/brain.
Back to top
View user's profile Send private message
costel78
Guru
Guru


Joined: 20 Apr 2007
Posts: 321

PostPosted: Mon Nov 29, 2010 5:35 pm    Post subject: Reply with quote

I made today in the morning the ebuild and installed it.
Thank you for your support!

Regarding glibc problem, I don't compile glibc with icc. The main reason it can go crazy during icc upgrade and leave you system unusable.
Are there any workaround, other than compile it with gcc before icc upgrade ?
_________________
Sorry for my English. I'm still learning this language.
Back to top
View user's profile Send private message
Tyler_Durden
Apprentice
Apprentice


Joined: 27 Jul 2004
Posts: 189
Location: Germany

PostPosted: Tue Nov 30, 2010 7:21 pm    Post subject: Reply with quote

costel78 wrote:
I made today in the morning the ebuild and installed it...

Can you provide your ebuild please?
_________________
Gentoo 17.1 x86_64
Intel Core i7-6700K
Asus MAXIMUS VIII HERO
Asus Geforce GTX1080 Ti
Asus STRIX RAID DLX
32GB DDR4
Samsung SSD SM951-NVMe 256GB
8x Seagate Archive (SATA-RAID 64TB)
Digital Devices Cine S2 V6.5 DVB Adapter
Back to top
View user's profile Send private message
costel78
Guru
Guru


Joined: 20 Apr 2007
Posts: 321

PostPosted: Tue Nov 30, 2010 8:53 pm    Post subject: Reply with quote

Yes, I can, but I tested it only in 64 bits environment. Also I'm not very proud about SRC_URI solution, but... take it as it is and hopefully improve it.

icc-2011.0.084.ebuild
Code:

# Copyright 1999-2010 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: /var/cvsroot/gentoo-x86/dev-lang/icc/icc-11.1.072-r1.ebuild,v 1.1 2010/11/26 13:20:12 jlec Exp $

EAPI="3"

inherit rpm versionator check-reqs

# http://registrationcenter-download.intel.com/akdlm/irc_nas/1959/l_ccompxe_intel64_2011.0.084.tgz
PB=intel64
PACKAGEID="l_ccompxe_${PB}_${PV}"
RELEASE="$(get_version_component_range 1-2)"
BUILD="$(get_version_component_range 3)"
PID=1959

DESCRIPTION="Intel compiler suite for Linux"
HOMEPAGE="http://www.intel.com/software/products/compilers/clin/"
SRC_COM="http://registrationcenter-download.intel.com/irc_nas/${PID}/${PACKAGEID}"
SRC_URI="amd64? ( ${SRC_COM}.tgz )"

LICENSE="Intel-SDP"
SLOT="0"
IUSE="eclipse +idb ipp mkl"
KEYWORDS="~amd64 ~ia64 ~x86 ~amd64-linux ~x86-linux"

RESTRICT="mirror"

DEPEND=""
RDEPEND="~virtual/libstdc++-3.3
   amd64? ( app-emulation/emul-linux-x86-compat )
   eclipse? ( >=dev-util/eclipse-sdk-3.4 )"

# DESTINATION="opt/intel/Compiler/${RELEASE}/${BUILD}"
DESTINATION="opt/intel/composerxe-2011.0.084"
EDESTINATION="${EROOT#/}${DESTINATION}"

QA_TEXTRELS="${EDESTINATION}/*"
QA_EXECSTACK="${EDESTINATION}/*"
QA_PRESTRIPPED="${EDESTINATION}/lib/*/.*libFNP.so ${EDESTINATION}/bin/*/.* ${EDESTINATION}/idb/*/*/.*"
QA_DT_HASH="
   ${EDESTINATION}/bin/*/.*
   ${EDESTINATION}/lib/*/.*
   ${EDESTINATION}/mkl/lib/*/.*
   ${EDESTINATION}/mkl/benchmarks/mp_linpack/bin_intel/*/.*
   ${EDESTINATION}/idb/*/*/.*"

pkg_setup() {
   CHECKREQS_MEMORY=1024
   CHECKREQS_DISK_BUILD=2048
   use idb && use ipp && use mkl && CHECKREQS_DISK_BUILD=3072
   check_reqs
   IARCH=ia32
   use amd64 && IARCH=intel64
   use ia64 && IARCH=ia64
}

src_unpack() {
   unpack ${A}
   mv "${WORKDIR}"/l_* "${S}"
   cd "${S}"
   # tbb is open source, thus built from sources in dev-cpp/tbb
   rm -f rpms/*tbb*.rpm
   use idb || rm -f rpms/*idb*.rpm
   use ipp || rm -f rpms/*ipp*.rpm
   use mkl || rm -f rpms/*mkl*.rpm
   use eclipse || rm -f rpms/*cdt*.rpm
   if has_version "~dev-lang/ifc-${PV}"; then
      rm -f rpms/*cprolib*.rpm
      use idb && built_with_use dev-lang/ifc idb && rm -f rpms/*idb*.rpm
      use mkl && built_with_use dev-lang/ifc mkl && rm -f rpms/*mkl*.rpm
   fi
   for x in rpms/intel*.rpm; do
      einfo "Extracting $(basename ${x})..."
      rpm_unpack ./${x} || die "rpm_unpack ${x} failed"
   done
}

link_eclipse_plugins() {
   ECLIPSE_V="$1"
   CDT_V="$2"
   einfo "Linking eclipse (v${ECLIPSE_V}) plugin cdt (v${CDT_V})"
   dodir /usr/$(get_libdir)/eclipse-${ECLIPSE_V}/plugins
   dodir /usr/$(get_libdir)/eclipse-${ECLIPSE_V}/features

   for f in "${DESTINATION}/eclipse_support/cdt${CDT_V}/eclipse/plugins"/*; do
      dosym "${EROOT}${f}" /usr/$(get_libdir)/eclipse-${ECLIPSE_V}/plugins
   done

   for f in "${DESTINATION}/eclipse_support/cdt${CDT_V}/eclipse/features"/*; do
      dosym "${EROOT}${f}" /usr/$(get_libdir)/eclipse-${ECLIPSE_V}/features
   done
   eend $?
}

src_prepare() {
   # from the PURGE_UB804_FNP in pset/install.sh
   # rm -f "${DESTINATION}"/lib/*/*libFNP.so || die

   # extract the tag function from the original install
   sed -n \
      -e "s|find \$DESTINATION|find ${DESTINATION}|g" \
      -e "s|@\$DESTINATION|@${EROOT}${DESTINATION}|g" \
      -e '/^UNTAG_CFG_FILES[[:space:]]*(/,/^}/p' \
      pset/install.sh > tag.sh || die
   # fix world writeable files
   [[ -d ${DESTINATION}/mkl ]] && chmod 644 \
      ${DESTINATION}/mkl/tools/{environment,builder}/* \
      ${DESTINATION}/mkl/tools/plugins/*/*
   # remove for collision (bug #288038)
   has_version "~dev-lang/ifc-${PV}" && \
      rm -f ${DESTINATION}/lib/*/locale/*/flexnet.cat
}

src_install() {
   einfo "Tagging"
   . ./tag.sh
   UNTAG_CFG_FILES

   keepdir /opt/intel/licenses
   einfo "Copying files"
   dodir "/${DESTINATION}"
   echo "cp -pPR ${S}/${DESTINATION}/* ${ED}/${DESTINATION}/"

   cp -pPR \
      ${DESTINATION}/* \
      "${ED}"/${DESTINATION}/ \
      || die "Copying ${PN} failed"

   local envf=05icfc
   cat > ${envf} <<-EOF
      PATH="${EROOT}${DESTINATION}/bin/${IARCH}"
      ROOTPATH="${EROOT}${DESTINATION}/bin/${IARCH}"
      LDPATH="${EROOT}${DESTINATION}/compiler/lib/${IARCH}:${EROOT}${DESTINATION}/compiler/idb/lib/${IARCH}"
      LIBRARY_PATH="${EROOT}${DESTINATION}/compiler/lib/${IARCH}:${EROOT}${DESTINATION}/compiler/idb/lib/${IARCH}"
      NLSPATH="${EROOT}${DESTINATION}/compiler/lib/intel64/locale/en_US/%N"
      MANPATH="${EROOT}${DESTINATION}/man/en_US"
   EOF
   if [[ ! -e "${EROOT}"etc/env.d/${envf} ]] ||
      [[ -n $(diff "${EROOT}"etc/env.d/${envf} ./${envf}) ]]; then
      doenvd ${envf} || die "doenvd ${envf} failed"
   fi
   [[ -d ${DESTINATION}/idb ]] && \
      dosym ../../common/com.intel.debugger.help_1.0.0 \
      ${DESTINATION}/idb/gui/${IARCH}/plugins

   if use eclipse; then
      if has_version 'dev-util/eclipse-sdk:3.4'; then
         link_eclipse_plugins "3.4" "5.0" || die
      fi
      if has_version 'dev-util/eclipse-sdk:3.5'; then
         link_eclipse_plugins "3.5" "6.0" || die
      fi
   fi
}

pkg_postinst() {
   elog "Make sure you have recieved the an Intel license."
   elog "To receive a non-commercial license, you need to register at:"
   elog "http://software.intel.com/en-us/articles/non-commercial-software-development/"
   elog "Install the license file into ${EROOT}opt/intel/licenses."
}

_________________
Sorry for my English. I'm still learning this language.
Back to top
View user's profile Send private message
n3rd
Guru
Guru


Joined: 30 Apr 2005
Posts: 328

PostPosted: Thu Dec 02, 2010 10:52 am    Post subject: Reply with quote

Code:
RDEPEND="~virtual/libstdc++-3.3
   amd64? ( app-emulation/emul-linux-x86-compat )
   eclipse? ( >=dev-util/eclipse-sdk-3.4 )
New ICC you can install without x86 libs on amd64.

costel78 wrote:
Regarding glibc problem, I don't compile glibc with icc. The main reason it can go crazy during icc upgrade and leave you system unusable.
Are there any workaround, other than compile it with gcc before icc upgrade ?
When you have instaled ICC headers and exported LIBRARY_PATH then you will have a problem to compile glibc with _GCC_. To solve this problem you need to unset LIBRARY_PATH in glibc ebuild or in /etc/portage/bashrc for glibc package.

regards,
daniel
_________________
"Jeśli coś jest niemożliwe do zrobienia, przychodzi ktoś kto o tym nie wie i robi to."
-- Albert Einstein

Zanim zadasz pytanie na forum, wykonaj: /etc/init.d/brain.
Back to top
View user's profile Send private message
kev009
n00b
n00b


Joined: 17 Oct 2005
Posts: 43
Location: Tempe, Arizona

PostPosted: Sun Dec 12, 2010 8:05 pm    Post subject: Reply with quote

Can anyone try compiling a program that uses pthread_rwlock_t? I am invoking icc -pthread but this these symbols are undefined. Does icc really not support POSIX.1-2001 rwlocks?
_________________
http://www.kev009.com
Back to top
View user's profile Send private message
Display posts from previous:   
Reply to topic    Gentoo Forums Forum Index Unsupported Software All times are GMT
Page 1 of 1

 
Jump to:  
You cannot post new topics in this forum
You cannot reply to topics in this forum
You cannot edit your posts in this forum
You cannot delete your posts in this forum
You cannot vote in polls in this forum